package WebFlow.test;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class pullClient 
{
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
        configReader config;
      
		
	//String WFSname = args[0];
	//String user    = args[1];
	try
	{
            //
            // Create ORB
            //
            ORB orb = ORB.init(args, new java.util.Properties());

	    //
	    // Get "hello" object
	    //

            String masterURL = args[0];
	    String ref = getIORFromURL(masterURL);
	    org.omg.CORBA.Object obj = orb.string_to_object(ref);
	    if(obj == null)
		throw new RuntimeException();
	    org.omg.CORBA.Object []ms = new org.omg.CORBA.Object[10];

	    WebFlowContext ws = WebFlowContextHelper.narrow(obj);
	    ms[0]= ws;
	    if(ws == null)
			throw new RuntimeException();
	    
	    System.out.println("Client: Created WFServerHelper");



           /* 
            org.omg.CORBA.Object obj = ws.addNewModule("fff");
            pbsModule pm = pbsModuleHelper.narrow(obj);
            pbsModule.executePBSCommand(......);
           */

           WebFlowContext ws1;
      	   try{
	        org.omg.CORBA.Object p1,p2,k1,k2,k;
		BeanContextChild bcc1,bcc2;
		WebFlowContext c1,c2,c3,wsr;
		
		ms[1]=ws = WebFlowContextHelper.narrow(ws.getWFServer("ali"));
		//wsr = WebFlowContextHelper.narrow(ws.getWFServer("ntserver"));
		System.out.println("Client: got ws");
		ms[2]=c1 = WebFlowContextHelper.narrow(ws.addNewContext("uc_1"));
		System.out.println("Client: got c1:"+c1);
		ms[3]=c2 = WebFlowContextHelper.narrow(c1.addNewContext("uc_2"));
		//c2 = WebFlowContextHelper.narrow(wsr.addNewContext("uc_2"));
		System.out.println("Client: got c2:"+c2);
		//test
		//c2 = WebFlowContextHelper.narrow(c1.addNewContext("uc_1"));
		//c2 = WebFlowContextHelper.narrow(ws.addNewContext("uc_2"));
		
		ms[4]=p1 = c1.addNewModule("hello_1");
		System.out.println("Client: got p1");
		ms[5]=p2 = c1.addNewModule("hello_2");
		System.out.println("Client: got p2");

        
		ms[6]=k1 = c2.addNewModule("hellogen_1");
		System.out.println("Client: got k1");
		ms[7]=k2 = c2.addNewModule("hellogen_2");
		System.out.println("Client: got k2");
		ms[8]= c1.addNewModule("hellogen_2");
		System.out.println("Client: got k2");

		hellogen hg = hellogenHelper.narrow(k1);
		hg.sayHello("Ali geldi Okula Cikti");
		

		System.out.println("Size :"+c1.size());
		boolean b1 = c1.contains(p1);
		System.out.println("c1 contains p1:"+b1);
		b1 = c1.contains(k1);
		System.out.println("c1 contains k1:"+b1);

      		bcc1  = BeanContextChildHelper.narrow(k1);
				
		c1.attachPushEvent(p1,"timeElapsed",k1,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c1.attachPullEvent(p1,"timeElapsed",k2);
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k2");
		c1.attachPushEvent(p1,"timeElapsed",ms[8],"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k2");
		String input;
		do
		  {
		    System.out.print("> ");
		    DataInputStream dataIn = new DataInputStream(System.in);
		    BufferedReader in =
		      new BufferedReader(new InputStreamReader(dataIn));
		    input = in.readLine();

		    if(input.indexOf("d") == 0){
		      //int c = Integet.parseInt(input.substring(1,1));
		      int index = input.indexOf("-");
		      int m1 = Integer.parseInt(input.substring(1,index));
		      int m2 = Integer.parseInt(input.substring(index+1));
		      System.out.println("Client: Detaching property from :"+m1+" to:"+m2);

		      System.out.println("Client: Detaching property p1-k1");
		      c1.detachPushEvent(ms[m1],"timeElapsed",ms[m2],"getTime");
		      System.out.println("Client: Detached property:"+
					 m1+"-"+m2);	
		    }
		    if(input.indexOf("rc") == 0){
		      int index = input.indexOf("-");
		      int ci = Integer.parseInt(input.substring(2,index));
		      int mi = Integer.parseInt(input.substring(index+1));
		      System.out.println("Client: Remove context:"+mi+" from context:"+ci);
		      WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
		      wfc.removeContext(ms[mi]);
		    }

		    if(input.indexOf("rm") == 0){
		      int index = input.indexOf("-");
		      int ci = Integer.parseInt(input.substring(2,index));
		      int mi = Integer.parseInt(input.substring(index+1));
		      System.out.println("Client: Remove child:"+mi+" from context:"+ci);
		      WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
		      wfc.removeModule(ms[mi]);
		    }
		    if(input.indexOf("cm") == 0){
		      int index = input.indexOf("-");
		      int lindex = input.lastIndexOf("-");
		      int ci = Integer.parseInt(input.substring(2,index));
		      int mi = Integer.parseInt(input.substring(index+1,
								lindex));
		      int mj = Integer.parseInt(input.substring(lindex+1));
		      System.out.println("Client: Remove child:"+mi+" from context:"+ci);
		      WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
		      wfc.copyModuleBinding(ms[mi], ms[mj]);
		    }
		     if(input.indexOf("ci") == 0){
		      int index = input.indexOf("-");
		      int ci = Integer.parseInt(input.substring(2,index));
		      String name = input.substring(index+1);
		      System.out.println("Client: Change Impl of :"+ci+" with:"+name);
		      BeanContextChild bcc = BeanContextChildHelper.narrow(ms[ci]);
		      bcc.changeImpl(name);
		    }
		    
		  }while(input.indexOf("x") != 0);
	   }catch(IOException e){
		}catch(PropertyVetoException e){System.out.println("Main:"+e);}
		 catch(WebFlow.NullPointerException e){System.out.println("Main:"+e);}

		/*
		  //WFSname ="wfs2";
		  k1 = ws.create_product(WFSname,user,"hellogen_1");
		  System.out.println("Client: Created hellogen_1");
		  k2 = ws.create_product(WFSname,user,"hellogen_2");
		  System.out.println("Client: Created hellogen_2");
		  */

		 /*
		   ws.attachPullEvent(p1,"Timer","timeElapsed",k1,"getTime");
		   System.out.println("Client: attached event p1-k1");
		   ws.attachPullEvent(p1,"Timer","timeElapsed",k2,"getTime");
		   System.out.println("Client: attached event p1-k2");
		   */
              

		 /*
		   ws.attachPullProperty(p1,"Hidate","getHidate", k1,"setHudate");
		   System.out.println("Client: attached property p1-k1");
		   ws.attachPullProperty(p1,"Hidate","getHidate", k2,"setHudate");
		   System.out.println("Client: attached property p1-k2");
		   */
		 
		 /*
		   ws.attachPullVetoableProperty(p1,"Hidate","getHidate", k1,"setHudate");
		   System.out.println("Client: attached property p1-k1");
		   ws.attachPullVetoableProperty(p1,"Hidate","getHidate", k2,"setHudate");
		   System.out.println("Client: attached property p1-k2");
		   */
	    
		 //ws.disconnect_product("hello_2");
		 //p2 = ws.create_product("hello_2");

		 //
		 // Main loop
		 //
		 System.out.println("Enter 'h' for hello or 'x' for exit:");
	   
	}
	catch(COMM_FAILURE ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }

  
    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
      
      return masterServerIOR;
      
    }
  
  

    
}




